# coding: utf-8

"""
    3Di API

    3Di simulation API (latest stable version: v3)   Framework release: 3.4.3   3Di core release: 3.5.0  deployed on:  03:07PM (UTC) on October 02, 2024  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: info@nelen-schuurmans.nl
    Generated by: https://openapi-generator.tech
"""


import logging
import pprint
import re  # noqa: F401

import six

from threedi_api_client.openapi.configuration import Configuration

logger = logging.getLogger(__name__)

class WaterQualityOutputSettings(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'simulation_id': 'int',
        'create_results': 'bool',
        'output_time_step': 'float',
        'output_start_time': 'float',
        'output_end_time': 'float',
        'output_precision': 'int',
        'customized_output_time_step': 'float',
        'customized_output_start_time': 'float',
        'customized_output_end_time': 'float',
        'customized_output_precision': 'int'
    }

    required_fields = [
    ]

    attribute_map = {
        'id': 'id',
        'simulation_id': 'simulation_id',
        'create_results': 'create_results',
        'output_time_step': 'output_time_step',
        'output_start_time': 'output_start_time',
        'output_end_time': 'output_end_time',
        'output_precision': 'output_precision',
        'customized_output_time_step': 'customized_output_time_step',
        'customized_output_start_time': 'customized_output_start_time',
        'customized_output_end_time': 'customized_output_end_time',
        'customized_output_precision': 'customized_output_precision'
    }

    def __init__(self, id=None, simulation_id=None, create_results=None, output_time_step=None, output_start_time=None, output_end_time=None, output_precision=None, customized_output_time_step=None, customized_output_start_time=None, customized_output_end_time=None, customized_output_precision=None, local_vars_configuration=None, fetched_from_api=False):  # noqa: E501
        """WaterQualityOutputSettings - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        # True if data is coming from API
        self._fetched_from_api = fetched_from_api

        self._id = None
        self._simulation_id = None
        self._create_results = None
        self._output_time_step = None
        self._output_start_time = None
        self._output_end_time = None
        self._output_precision = None
        self._customized_output_time_step = None
        self._customized_output_start_time = None
        self._customized_output_end_time = None
        self._customized_output_precision = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if simulation_id is not None:
            self.simulation_id = simulation_id
        if create_results is not None:
            self.create_results = create_results
        self.output_time_step = output_time_step
        if output_start_time is not None:
            self.output_start_time = output_start_time
        if output_end_time is not None:
            self.output_end_time = output_end_time
        if output_precision is not None:
            self.output_precision = output_precision
        self.customized_output_time_step = customized_output_time_step
        if customized_output_start_time is not None:
            self.customized_output_start_time = customized_output_start_time
        if customized_output_end_time is not None:
            self.customized_output_end_time = customized_output_end_time
        if customized_output_precision is not None:
            self.customized_output_precision = customized_output_precision

    @property
    def id(self):
        """Gets the id of this WaterQualityOutputSettings.  # noqa: E501


        :return: The id of this WaterQualityOutputSettings.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this WaterQualityOutputSettings.


        :param id: The id of this WaterQualityOutputSettings.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def simulation_id(self):
        """Gets the simulation_id of this WaterQualityOutputSettings.  # noqa: E501


        :return: The simulation_id of this WaterQualityOutputSettings.  # noqa: E501
        :rtype: int
        """
        return self._simulation_id

    @simulation_id.setter
    def simulation_id(self, simulation_id):
        """Sets the simulation_id of this WaterQualityOutputSettings.


        :param simulation_id: The simulation_id of this WaterQualityOutputSettings.  # noqa: E501
        :type: int
        """

        self._simulation_id = simulation_id

    @property
    def create_results(self):
        """Gets the create_results of this WaterQualityOutputSettings.  # noqa: E501

        Create domain wide results file.  # noqa: E501

        :return: The create_results of this WaterQualityOutputSettings.  # noqa: E501
        :rtype: bool
        """
        return self._create_results

    @create_results.setter
    def create_results(self, create_results):
        """Sets the create_results of this WaterQualityOutputSettings.

        Create domain wide results file.  # noqa: E501

        :param create_results: The create_results of this WaterQualityOutputSettings.  # noqa: E501
        :type: bool
        """

        self._create_results = create_results

    @property
    def output_time_step(self):
        """Gets the output_time_step of this WaterQualityOutputSettings.  # noqa: E501

        Output time step in seconds.  # noqa: E501

        :return: The output_time_step of this WaterQualityOutputSettings.  # noqa: E501
        :rtype: float
        """
        return self._output_time_step

    @output_time_step.setter
    def output_time_step(self, output_time_step):
        """Sets the output_time_step of this WaterQualityOutputSettings.

        Output time step in seconds.  # noqa: E501

        :param output_time_step: The output_time_step of this WaterQualityOutputSettings.  # noqa: E501
        :type: float
        """
        if (self.local_vars_configuration.client_side_validation and
                output_time_step is not None and output_time_step < 1E-14):  # noqa: E501
            self.__handle_validation_error("Invalid value for `output_time_step`, must be a value greater than or equal to `1E-14`")  # noqa: E501

        self._output_time_step = output_time_step

    @property
    def output_start_time(self):
        """Gets the output_start_time of this WaterQualityOutputSettings.  # noqa: E501

        Output start time in seconds.  # noqa: E501

        :return: The output_start_time of this WaterQualityOutputSettings.  # noqa: E501
        :rtype: float
        """
        return self._output_start_time

    @output_start_time.setter
    def output_start_time(self, output_start_time):
        """Sets the output_start_time of this WaterQualityOutputSettings.

        Output start time in seconds.  # noqa: E501

        :param output_start_time: The output_start_time of this WaterQualityOutputSettings.  # noqa: E501
        :type: float
        """
        if (self.local_vars_configuration.client_side_validation and
                output_start_time is not None and output_start_time < 0):  # noqa: E501
            self.__handle_validation_error("Invalid value for `output_start_time`, must be a value greater than or equal to `0`")  # noqa: E501

        self._output_start_time = output_start_time

    @property
    def output_end_time(self):
        """Gets the output_end_time of this WaterQualityOutputSettings.  # noqa: E501

        Output end time in seconds.  # noqa: E501

        :return: The output_end_time of this WaterQualityOutputSettings.  # noqa: E501
        :rtype: float
        """
        return self._output_end_time

    @output_end_time.setter
    def output_end_time(self, output_end_time):
        """Sets the output_end_time of this WaterQualityOutputSettings.

        Output end time in seconds.  # noqa: E501

        :param output_end_time: The output_end_time of this WaterQualityOutputSettings.  # noqa: E501
        :type: float
        """
        if (self.local_vars_configuration.client_side_validation and
                output_end_time is not None and output_end_time < 1E-14):  # noqa: E501
            self.__handle_validation_error("Invalid value for `output_end_time`, must be a value greater than or equal to `1E-14`")  # noqa: E501

        self._output_end_time = output_end_time

    @property
    def output_precision(self):
        """Gets the output_precision of this WaterQualityOutputSettings.  # noqa: E501

        Single or double precision output.  # noqa: E501

        :return: The output_precision of this WaterQualityOutputSettings.  # noqa: E501
        :rtype: int
        """
        return self._output_precision

    @output_precision.setter
    def output_precision(self, output_precision):
        """Sets the output_precision of this WaterQualityOutputSettings.

        Single or double precision output.  # noqa: E501

        :param output_precision: The output_precision of this WaterQualityOutputSettings.  # noqa: E501
        :type: int
        """

        self._output_precision = output_precision

    @property
    def customized_output_time_step(self):
        """Gets the customized_output_time_step of this WaterQualityOutputSettings.  # noqa: E501

        Customized output time step in seconds.  # noqa: E501

        :return: The customized_output_time_step of this WaterQualityOutputSettings.  # noqa: E501
        :rtype: float
        """
        return self._customized_output_time_step

    @customized_output_time_step.setter
    def customized_output_time_step(self, customized_output_time_step):
        """Sets the customized_output_time_step of this WaterQualityOutputSettings.

        Customized output time step in seconds.  # noqa: E501

        :param customized_output_time_step: The customized_output_time_step of this WaterQualityOutputSettings.  # noqa: E501
        :type: float
        """
        if (self.local_vars_configuration.client_side_validation and
                customized_output_time_step is not None and customized_output_time_step < 1E-14):  # noqa: E501
            self.__handle_validation_error("Invalid value for `customized_output_time_step`, must be a value greater than or equal to `1E-14`")  # noqa: E501

        self._customized_output_time_step = customized_output_time_step

    @property
    def customized_output_start_time(self):
        """Gets the customized_output_start_time of this WaterQualityOutputSettings.  # noqa: E501

        Customized output start time in seconds.  # noqa: E501

        :return: The customized_output_start_time of this WaterQualityOutputSettings.  # noqa: E501
        :rtype: float
        """
        return self._customized_output_start_time

    @customized_output_start_time.setter
    def customized_output_start_time(self, customized_output_start_time):
        """Sets the customized_output_start_time of this WaterQualityOutputSettings.

        Customized output start time in seconds.  # noqa: E501

        :param customized_output_start_time: The customized_output_start_time of this WaterQualityOutputSettings.  # noqa: E501
        :type: float
        """
        if (self.local_vars_configuration.client_side_validation and
                customized_output_start_time is not None and customized_output_start_time < 0):  # noqa: E501
            self.__handle_validation_error("Invalid value for `customized_output_start_time`, must be a value greater than or equal to `0`")  # noqa: E501

        self._customized_output_start_time = customized_output_start_time

    @property
    def customized_output_end_time(self):
        """Gets the customized_output_end_time of this WaterQualityOutputSettings.  # noqa: E501

        Customized output end time in seconds.  # noqa: E501

        :return: The customized_output_end_time of this WaterQualityOutputSettings.  # noqa: E501
        :rtype: float
        """
        return self._customized_output_end_time

    @customized_output_end_time.setter
    def customized_output_end_time(self, customized_output_end_time):
        """Sets the customized_output_end_time of this WaterQualityOutputSettings.

        Customized output end time in seconds.  # noqa: E501

        :param customized_output_end_time: The customized_output_end_time of this WaterQualityOutputSettings.  # noqa: E501
        :type: float
        """
        if (self.local_vars_configuration.client_side_validation and
                customized_output_end_time is not None and customized_output_end_time < 1E-14):  # noqa: E501
            self.__handle_validation_error("Invalid value for `customized_output_end_time`, must be a value greater than or equal to `1E-14`")  # noqa: E501

        self._customized_output_end_time = customized_output_end_time

    @property
    def customized_output_precision(self):
        """Gets the customized_output_precision of this WaterQualityOutputSettings.  # noqa: E501

        Single or double precision output for customized results.  # noqa: E501

        :return: The customized_output_precision of this WaterQualityOutputSettings.  # noqa: E501
        :rtype: int
        """
        return self._customized_output_precision

    @customized_output_precision.setter
    def customized_output_precision(self, customized_output_precision):
        """Sets the customized_output_precision of this WaterQualityOutputSettings.

        Single or double precision output for customized results.  # noqa: E501

        :param customized_output_precision: The customized_output_precision of this WaterQualityOutputSettings.  # noqa: E501
        :type: int
        """

        self._customized_output_precision = customized_output_precision

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def __handle_validation_error(self, message):
        # Only raise ValueError when not fetched from API
        from threedi_api_client import __version__ as VERSION

        if not self._fetched_from_api:
            raise ValueError(message + f" It is possible that the current threedi-api-client version ({VERSION}) is out of date: consult https://pypi.org/project/threedi-api-client/ and consider upgrading.")  # noqa: E501
        logger.warning(message + " Please update to the latest threedi-api-client version.")  # noqa: E501

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WaterQualityOutputSettings):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, WaterQualityOutputSettings):
            return True

        return self.to_dict() != other.to_dict()
